'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var createHashModule = require('create-hash');
var createHmacModule = require('create-hmac');
var randomBytesModule = require('@react-native-module/randombytes');
var signAlogos = require('browserify-sign/browser/algorithms.json');
var pbkdf2Moule = require('@react-native-module/pbkdf2');
var aes = require('browserify-cipher');
var dh = require('diffie-hellman');
var sign = require('browserify-sign');
var createEcdhModule = require('create-ecdh');
var publicEncryptModule = require('public-encrypt');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var createHashModule__default = /*#__PURE__*/_interopDefaultLegacy(createHashModule);
var createHmacModule__default = /*#__PURE__*/_interopDefaultLegacy(createHmacModule);
var randomBytesModule__default = /*#__PURE__*/_interopDefaultLegacy(randomBytesModule);
var signAlogos__default = /*#__PURE__*/_interopDefaultLegacy(signAlogos);
var pbkdf2Moule__namespace = /*#__PURE__*/_interopNamespace(pbkdf2Moule);
var aes__default = /*#__PURE__*/_interopDefaultLegacy(aes);
var dh__default = /*#__PURE__*/_interopDefaultLegacy(dh);
var sign__default = /*#__PURE__*/_interopDefaultLegacy(sign);
var createEcdhModule__default = /*#__PURE__*/_interopDefaultLegacy(createEcdhModule);
var publicEncryptModule__default = /*#__PURE__*/_interopDefaultLegacy(publicEncryptModule);

const Hash = createHashModule__default["default"];
const createHash = Hash;
const Hmac = createHmacModule__default["default"];
const createHmac = createHmacModule__default["default"];
const randomBytes = randomBytesModule__default["default"];
const rng = randomBytes;
const pseudoRandomBytes = randomBytes;
const prng = randomBytes;
const hashes = ['sha1', 'sha224', 'sha256', 'sha384', 'sha512', 'md5', 'rmd160'].concat(Object.keys(signAlogos__default["default"]));
function getHashes() {
    return hashes;
}
const pbkdf2 = pbkdf2Moule__namespace.pbkdf2;
const pbkdf2Sync = pbkdf2Moule__namespace.pbkdf2Sync;
const Cipher = aes__default["default"].Cipher;
const createCipher = aes__default["default"].createCipher;
const Cipheriv = aes__default["default"].Cipheriv;
const createCipheriv = aes__default["default"].createCipheriv;
const Decipher = aes__default["default"].Decipher;
const createDecipher = aes__default["default"].createDecipher;
const Decipheriv = aes__default["default"].Decipheriv;
const createDecipheriv = aes__default["default"].createDecipheriv;
const getCiphers = aes__default["default"].getCiphers;
const listCiphers = aes__default["default"].listCiphers;
const DiffieHellmanGroup = dh__default["default"].DiffieHellmanGroup;
const createDiffieHellmanGroup = dh__default["default"].createDiffieHellmanGroup;
const getDiffieHellman = dh__default["default"].getDiffieHellman;
const createDiffieHellman = dh__default["default"].createDiffieHellman;
const DiffieHellman = dh__default["default"].DiffieHellman;
const createSign = sign__default["default"].createSign;
const Sign = sign__default["default"].Sign;
const createVerify = sign__default["default"].createVerify;
const Verify = sign__default["default"].Verify;
const createECDH = createEcdhModule__default["default"];
const publicEncrypt = publicEncryptModule__default["default"].publicEncrypt;
const privateEncrypt = publicEncryptModule__default["default"].privateEncrypt;
const publicDecrypt = publicEncryptModule__default["default"].publicDecrypt;
const privateDecrypt = publicEncryptModule__default["default"].privateDecrypt;
const createCredentials = () => {
    throw new Error([
        'sorry, createCredentials is not implemented yet',
        'we accept pull requests',
        'https://github.com/crypto-browserify/crypto-browserify'
    ].join('\n'));
};

exports.Cipher = Cipher;
exports.Cipheriv = Cipheriv;
exports.Decipher = Decipher;
exports.Decipheriv = Decipheriv;
exports.DiffieHellman = DiffieHellman;
exports.DiffieHellmanGroup = DiffieHellmanGroup;
exports.Hash = Hash;
exports.Hmac = Hmac;
exports.Sign = Sign;
exports.Verify = Verify;
exports.createCipher = createCipher;
exports.createCipheriv = createCipheriv;
exports.createCredentials = createCredentials;
exports.createDecipher = createDecipher;
exports.createDecipheriv = createDecipheriv;
exports.createDiffieHellman = createDiffieHellman;
exports.createDiffieHellmanGroup = createDiffieHellmanGroup;
exports.createECDH = createECDH;
exports.createHash = createHash;
exports.createHmac = createHmac;
exports.createSign = createSign;
exports.createVerify = createVerify;
exports.getCiphers = getCiphers;
exports.getDiffieHellman = getDiffieHellman;
exports.getHashes = getHashes;
exports.listCiphers = listCiphers;
exports.pbkdf2 = pbkdf2;
exports.pbkdf2Sync = pbkdf2Sync;
exports.privateDecrypt = privateDecrypt;
exports.privateEncrypt = privateEncrypt;
exports.prng = prng;
exports.pseudoRandomBytes = pseudoRandomBytes;
exports.publicDecrypt = publicDecrypt;
exports.publicEncrypt = publicEncrypt;
exports.randomBytes = randomBytes;
exports.rng = rng;
