import createHashModule from 'create-hash';
import createHmacModule from 'create-hmac';
import randomBytesModule from '@react-native-module/randombytes';
import signAlogos from 'browserify-sign/browser/algorithms.json';
import * as pbkdf2Moule from '@react-native-module/pbkdf2';
import aes from 'browserify-cipher';
import dh from 'diffie-hellman';
import sign from 'browserify-sign';
import createEcdhModule from 'create-ecdh';
import publicEncryptModule from 'public-encrypt';

const Hash = createHashModule;
const createHash = Hash;
const Hmac = createHmacModule;
const createHmac = createHmacModule;
const randomBytes = randomBytesModule;
const rng = randomBytes;
const pseudoRandomBytes = randomBytes;
const prng = randomBytes;
const hashes = ['sha1', 'sha224', 'sha256', 'sha384', 'sha512', 'md5', 'rmd160'].concat(Object.keys(signAlogos));
function getHashes() {
    return hashes;
}
const pbkdf2 = pbkdf2Moule.pbkdf2;
const pbkdf2Sync = pbkdf2Moule.pbkdf2Sync;
const Cipher = aes.Cipher;
const createCipher = aes.createCipher;
const Cipheriv = aes.Cipheriv;
const createCipheriv = aes.createCipheriv;
const Decipher = aes.Decipher;
const createDecipher = aes.createDecipher;
const Decipheriv = aes.Decipheriv;
const createDecipheriv = aes.createDecipheriv;
const getCiphers = aes.getCiphers;
const listCiphers = aes.listCiphers;
const DiffieHellmanGroup = dh.DiffieHellmanGroup;
const createDiffieHellmanGroup = dh.createDiffieHellmanGroup;
const getDiffieHellman = dh.getDiffieHellman;
const createDiffieHellman = dh.createDiffieHellman;
const DiffieHellman = dh.DiffieHellman;
const createSign = sign.createSign;
const Sign = sign.Sign;
const createVerify = sign.createVerify;
const Verify = sign.Verify;
const createECDH = createEcdhModule;
const publicEncrypt = publicEncryptModule.publicEncrypt;
const privateEncrypt = publicEncryptModule.privateEncrypt;
const publicDecrypt = publicEncryptModule.publicDecrypt;
const privateDecrypt = publicEncryptModule.privateDecrypt;
const createCredentials = () => {
    throw new Error([
        'sorry, createCredentials is not implemented yet',
        'we accept pull requests',
        'https://github.com/crypto-browserify/crypto-browserify'
    ].join('\n'));
};

export { Cipher, Cipheriv, Decipher, Decipheriv, DiffieHellman, DiffieHellmanGroup, Hash, Hmac, Sign, Verify, createCipher, createCipheriv, createCredentials, createDecipher, createDecipheriv, createDiffieHellman, createDiffieHellmanGroup, createECDH, createHash, createHmac, createSign, createVerify, getCiphers, getDiffieHellman, getHashes, listCiphers, pbkdf2, pbkdf2Sync, privateDecrypt, privateEncrypt, prng, pseudoRandomBytes, publicDecrypt, publicEncrypt, randomBytes, rng };
